#include <amxmodx>
#include <amxmisc>
#include <amxconst>
#include <cstrike>
#include <engine>
#include <fun>


#define PLUGIN "CS Advanced Game-Modes"
#define VERSION "1.0"
#define AUTHOR "AlMod"

#define MODE_DEFAULT		0
#define MODE_FLAG		1
#define MODE_DD			2

#define TERRORISTS 		1
#define COUNTER-TERRORISTS	2

new g_Mode = 0

new Float:g_RedFlagCoords[3]
new Float:g_BlueFlagCoords[3]

new const g_FlagModel[] = "models/csagm/flag.mdl" 

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_cvar("amx_csmode","0")	// 0 -  CS, 1 - Flag, 2 - Double Domination
	
	//register_event("HLTV","NewRound","a","1=0","2=0")
	//register_event("ResetHUD","NewRound","a")
	register_logevent("RoundStart",2,"1=Round_Start")
	
	new configsDir[64]
	get_configsdir(configsDir, 63) 

	server_cmd("exec %s/CSAGM.cfg", configsDir)
}

public plugin_cfg()
{
	g_Mode = get_cvar_num("amx_csmode")
	ClearTeamTargets
	if (g_Mode==MODE_FLAG) ReadFlagsCoords
}

public plugin_precache()
{
	precache_model(g_FlagModel)
}

public RoundStart()
{
	new players[32],num
	get_players(players,num)

	set_hudmessage(255, 170, 0, -1.0, 0.2, 0, 6.0, 12.0)
	
	for (new i=0;i<num;i++)
	{
		new id=players[i]
		show_hudmessage(id, "Flags Placed! Starting play!")
	}
	
	SetMode(g_Mode)
}

public SetMode(Mode)
{
	switch(g_Mode)
	{
		case MODE_FLAG: SetModeFlag
		case MODE_DD: SetModeDD
	}
}

public SetModeFlag()
{
	RemoveEntityAll("flag_red")
	RemoveEntityAll("flag_blue")
	MakeFlag(TERRORISTS)
	MakeFlag(COUNTER-TERRORISTS)
}

public SetModeDD()
{
	
}

/*   ,     */

public ClearTeamTargets()
{
	new mapname[24]
	get_mapname(mapname, 23)

	if (containi(mapname, "de_") != -1)
	{
		RemoveEntityAll("func_bomb_target")
		RemoveEntityAll("info_bomb_target")
		log_amx("'DE_' map - bombplaces deleted")
	}
	if (containi(mapname, "as_") != -1)
	{
		RemoveEntityAll("info_vip_start")
		RemoveEntityAll("func_vip_safetyzone")
		log_amx("'AS_' map - vipzone deleted")
	}
	if (containi(mapname, "cs_") != -1)
	{
		RemoveEntityAll("func_hostage_rescue")
		RemoveEntityAll("info_hostage_rescue")
		RemoveEntityAll("hostage_entity")
		log_amx("'CS_' map - hostages deleted")
	}
	//log_amx("No correct map name. Nothing deleted")
}

stock RemoveEntityAll(name[])
{
	new ent = find_ent_by_class(0, name)
	new temp
	while (ent)
	{
		temp = find_ent_by_class(ent, name)
		remove_entity(ent)
		ent = temp
	}
}

/*      */

public ReadFlagsCoords()
{
	new Map[32], config[32],  MapFile[64]
	new FlagsIndex
	
	FlagsIndex=0

	get_mapname(Map, 31)
	get_configsdir(config, 31 )
	format(MapFile, 63, "%s\CSAGM\flags\%s.flags", config, Map);

	if (file_exists(MapFile)) 
	{
		new Data[124], len
		new line = 0
		new pos[12][8]
		new Float:FOrigin[3]

		while(FlagsIndex < 3 && (line = read_file(MapFile , line , Data , 123 , len) ) != 0 ) 
		{
			if (strlen(Data)<2 || Data[0] == '[')
			continue

			parse(Data, pos[1], 7, pos[2], 7, pos[3], 7)
			
			FlagsIndex++


			// 
			FOrigin[0] = str_to_float(pos[1])
			FOrigin[1] = str_to_float(pos[2])
			FOrigin[2] = str_to_float(pos[3])

			if (FlagsIndex==1)
			{
				g_RedFlagCoords=FOrigin
				log_amx("Red Flag Coordinates loaded")
			}
			else if (FlagsIndex==2)
			{
				g_BlueFlagCoords=FOrigin
				log_amx("Blue Flag Coordinates loaded")
			}
		}
		log_amx("Flags files found! Coordinates Successfully readed")

	} else {
		log_amx("Flags files not founded")
		log_amx("Reseting Game mode to 'Default CS' (0)")
		g_Mode=MODE_DEFAULT
		SetMode(g_Mode)
	}

	return 1
}

/*    -. TeamIndex -   1  2,   */

public MakeFlag(TeamIndex)
{
	new ent = create_entity("info_target")
	
	switch (TeamIndex)
	{
		case TERRORISTS: 
		{
			entity_set_origin(ent,g_RedFlagCoords)
			entity_set_string(ent,EV_SZ_classname,"flag_red")
			log_amx("Red Flag Placed")
			//set_user_rendering(ent,kRenderFxGlowShell,255,0,0,kRenderNormal,15) 
		}
		case COUNTER-TERRORISTS: 
		{
			entity_set_origin(ent,g_BlueFlagCoords)
			entity_set_string(ent,EV_SZ_classname,"flag_blue")
			log_amx("Blue Flag Placed")
			//set_user_rendering(ent,kRenderFxGlowShell,0,0,255,kRenderNormal,15) 
		}
	}
	
	entity_set_model(ent,g_FlagModel)
	entity_set_int(ent,EV_INT_solid, SOLID_TRIGGER)
	
	new Float:maxs[3] = {16.0,16.0,36.0}
	new Float:mins[3] = {-16.0,-16.0,-36.0}
	entity_set_size(ent,mins,maxs)

	entity_set_float(ent,EV_FL_animtime,2.0)
	entity_set_float(ent,EV_FL_framerate,1.0)
	entity_set_int(ent,EV_INT_sequence,1)
	
	drop_to_floor(ent)
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
